import matplotlib.pyplot as plt


def top_label_cbar(label, tight=True, ax=None):
    cax = make_top_label_cbar(label, ax)
    if tight:
        plt.tight_layout()
    adjust_top_label_cbar(cax)
    return cax


def make_top_label_cbar(label, ax=None):
    if ax is None:
        ax = plt.gca()
    # Create small colorbar (allocate space for label)
    cb = plt.colorbar(ax=ax, shrink=0.8)
    cax = cb.ax
    # Add label on top.
    cax.set_xlabel(label)
    cax.xaxis.set_label_position('top')
    return cax


def adjust_top_label_cbar(cax):
    # Adjust axis position.
    pos1 = cax.get_position()
    yshift = pos1.height * 0.06 / 0.8
    pos2 = [pos1.x0, pos1.y0 - yshift, pos1.width, pos1.height]
    cax.set_position(pos2)
    # Adjust label position.
    cax.xaxis.set_label_coords(2.5, 1.075)
