from dos_plots import *

# from dos_core import *

wd = "/scratch_remote/omega_zero_testing/"
name = "ref_res8"
mpb_cache = True
dos_cache = False
w_min = 0.0
dw = 5e-3


def mpb_step():
    if mpb_cache:
        return
    # Initialize mpb objects.
    mpb_params = {"n_low": 1.5, "n_high": 1.5 + 1e-9, "num_bands": 4, "resolution": 2}
    mpb_grid = MpbGrid2D(0, 0.5, 0, 2.1, 1e-3, 'y')
    # Loop low/high resolutions.
    mpb_input = MpbInput(mpb_params, mpb_grid, sym=True)
    run_mpb_calculation(name, mpb_input, wd=wd)


def dos_step():
    if dos_cache:
        return
    w_bins = np.arange(w_min, 1.2 + dw, dw)
    dos_result_from_mpb_result(os.path.join(wd, name), w_bins, suffix="wmin{}".format(w_min))


def calc_integral(dos_result, start, end):
    data = assemble_dos_data(dos_result, "dos3d", rel=False)
    hits = np.logical_and(dos_result.w_bins > start, dos_result.w_bins < end)
    return np.sum(data[hits])


mpb_step()
dos_step()

# Plotting stuff.
int1 = []
int2 = []
for dw in [1e-3, dw]:
    for w_min in [0.0]:
        dos_result = load(os.path.join(wd, name, "dos_result_dw{:.0e}_wmin{}.json".format(dw, w_min)))
        plot_dos_result(dos_result, "dos3d") #, fltr=lambda x: gf1d(x, 5))
        # print("DOS2D, dw = {}: {}".format(dw, np.sum(assemble_dos_data(dos_result, "dos2d", rel=False))))
        # int1.append(calc_integral(dw, 1.0 - w_min, 1.025 - w_min))
        # int2.append(calc_integral(dos_result, 1.075 - w_min, 1.1 - w_min))
# print("Ratio 1: {}".format(int1[-1] / int1[0]))
# print("Ratio 2: {}".format(int2[-1] / int2[0]))

plt.show()
